--============================================================================================================
--                                          JOC DE PROVES
--============================================================================================================
declare
V_RSP VARCHAR2(100);
V_ERR_DESC VARCHAR2(400);
V_NUM NUMBER;
begin
--============================================================================================================
--             PROVES dels disparadors que s'han definit pel clcul de l'estadstic 3 (qPropietaris)
--============================================================================================================
dbms_output.put_line('--============================================================================================================');
dbms_output.put_line('--             PROVES dels disparadors que s''han definit pel clcul de l''estadstic 3 (qPropietaris)');
dbms_output.put_line('--============================================================================================================');
select qpropietaris into v_num
from accio
where ticker like 'PECI';
dbms_output.put_line('Ara hi ha '||v_num||' propietaris d''accions PECI');
-- alta d'un nou registre a la taula CARTERA
PROC_ALTA_CARTERA('PECI',date '2015-03-04',2,100,v_RSP,v_ERR_DESC); 
select qpropietaris into v_num
from accio
where ticker like 'PECI';
dbms_output.put_line('Desprs de realitzar una alta en CARTERA hi ha '||v_num||' propietaris d''accions PECI');
-- modificaci d'un registre de la taula CARTERA que fa que les unitats quedin a 0
PROC_MODIF_CARTERA(2,'PECI',0,NULL,1,0,1,0,v_RSP,v_ERR_DESC); 
select qpropietaris into v_num
from accio
where ticker like 'PECI';
dbms_output.put_line('Desprs de realitzar una modificaci en CARTERA hi ha '||v_num||' propietaris d''accions PECI');
-- baixa lgica d'un registre a la taula CARTERA
select qpropietaris into v_num
from accio
where ticker like 'GRF';
dbms_output.put_line('Ara hi ha '||v_num||' propietaris d''accions GRF');
PROC_BAIXA_CARTERA('GRF',5,v_RSP,v_ERR_DESC); -- OK
select qpropietaris into v_num
from accio
where ticker like 'GRF';
dbms_output.put_line('Desprs de fer una baixa d''una cartera hi ha '||v_num||' propietaris d''accions GRF');
--============================================================================================================
--                            CONSULTA 1
--============================================================================================================

dbms_output.put_line('--============================================================================================================');
dbms_output.put_line('--                            CONSULTA 1');
dbms_output.put_line('--============================================================================================================');
PROC_1(DATE '2015-04-04',1,V_RSP,V_ERR_DESC); -- KO:: client donat de baixa
PROC_1(DATE '2014-04-01',4,V_RSP,V_ERR_DESC); -- KO:: DATA FORA DEL RANG
PROC_1(DATE '2015-04-02',12,V_RSP,V_ERR_DESC);  -- KO:: CLIENT INEXISTENT
PROC_1(DATE '2015-04-05',2,V_RSP,V_ERR_DESC); -- KO:: CLIENT AMB CARTERA BUIDA 
PROC_1(DATE '2015-04-03',4,V_RSP,V_ERR_DESC); 
PROC_1(DATE '2015-04-04',5,V_RSP,V_ERR_DESC); 
PROC_1(DATE '2015-05-04',5,V_RSP,V_ERR_DESC); 
PROC_1(DATE '2015-04-12',6,V_RSP,V_ERR_DESC); 
--============================================================================================================
--                            CONSULTA 2
--============================================================================================================
dbms_output.put_line('--============================================================================================================');
dbms_output.put_line('--                            CONSULTA 2');
dbms_output.put_line('--============================================================================================================');
PROC_2('2014',V_RSP,V_ERR_DESC); -- ko --> l'any no s vlid per la informaci que hi ha a la bD
PROC_2('2015',V_RSP,V_ERR_DESC); 
PROC_2('2016',V_RSP,V_ERR_DESC);  -- KO --> NO HI HA ORDRES DE COMPRA/VENDA DURAN L'ANY 2016
--============================================================================================================
--                            CONSULTA 3
--============================================================================================================
dbms_output.put_line('--============================================================================================================');
dbms_output.put_line('--                            CONSULTA 3');
dbms_output.put_line('--============================================================================================================');
PROC_3('2014',V_RSP,V_ERR_DESC); -- ko --> l'any no s vlid per la informaci que hi ha dins la BD
PROC_3('2015',V_RSP,V_ERR_DESC); -- 
PROC_3('2016',V_RSP,V_ERR_DESC); -- KO --> NO s'ha executat cap operaci duran l'any 2016
--============================================================================================================
--                            CONSULTA 4
--============================================================================================================
dbms_output.put_line('--============================================================================================================');
dbms_output.put_line('--                            CONSULTA 4');
dbms_output.put_line('--============================================================================================================');
proc_4(v_rsp,v_err_desc); --> NO HO FA B AMB LES DADES QUE HI HA REALMENT A LA bd
--============================================================================================================
--                            ESTADSTIC 1
--============================================================================================================
dbms_output.put_line('--============================================================================================================');
dbms_output.put_line('--                            ESTADSTIC 1');
dbms_output.put_line('--============================================================================================================');
proc_cartera_mes(1,1,2015,v_RSP,v_ERR_DESC);--  KO:: client donat de baixa 
proc_cartera_mes(2,13,2015,v_RSP,v_ERR_DESC);--  KO: mes incorrecte
proc_cartera_mes(2,2,2013,v_RSP,v_ERR_DESC);  -- KO: any incorrecte
proc_cartera_mes(9,4,2015,v_RSP,v_ERR_DESC); -- KO: client inexistent
proc_cartera_mes(2,2,2015,v_RSP,v_ERR_DESC); 
proc_cartera_mes(4,4,2015,v_RSP,v_ERR_DESC);
proc_cartera_mes(5,7,2015,v_RSP,v_ERR_DESC);
proc_cartera_mes(6,2,2016,v_RSP,v_ERR_DESC);
proc_cartera_mes(7,4,2015,v_RSP,v_ERR_DESC);
PROC_EST_1 (2,'INVENT',2015,v_RSP,v_ERR_DESC); -- KO: mes incorrecte
PROC_EST_1 (4,'ABRIL',2017,v_RSP,v_ERR_DESC); -- KO: data posterior
PROC_EST_1 (14,'FEBRER',2015,v_RSP,v_ERR_DESC); -- KO: client no existeix
PROC_EST_1 (3,'MAIG',2015,v_RSP,v_ERR_DESC); -- KO: client donat de baixa
PROC_EST_1 (2,'FEBRER',2015,v_RSP,v_ERR_DESC);
PROC_EST_1 (4,'ABRIL',2015,v_RSP,v_ERR_DESC);
PROC_EST_1 (6,'FEBRER',2015,v_RSP,v_ERR_DESC);
PROC_EST_1 (7,'ABRIL',2015,v_RSP,v_ERR_DESC);
-- FALTA: CRIDAR ALS PROC_EST_2 I PROC_EST_3
--============================================================================================================
--                            ESTADSTIC 2
--============================================================================================================
dbms_output.put_line('--============================================================================================================');
dbms_output.put_line('--                            ESTADSTIC 2 --> accions disponibles');
dbms_output.put_line('--============================================================================================================');
PROC_EST_2 ('IBM',v_RSP,v_ERR_DESC);
PROC_EST_2 ('RR',v_RSP,v_ERR_DESC);
PROC_EST_2 ('AMA',v_RSP,v_ERR_DESC);
PROC_EST_2 ('CSCO',v_RSP,v_ERR_DESC);
PROC_EST_2 ('SACYR',v_RSP,v_ERR_DESC);
PROC_EST_2 ('NOKI',v_RSP,v_ERR_DESC);
--============================================================================================================
--                            ESTADSTIC 3
--============================================================================================================

dbms_output.put_line('--============================================================================================================');
dbms_output.put_line('--                            ESTADSTIC 3 --> Quantitats de propietaris d''una acci');
dbms_output.put_line('--============================================================================================================');
PROC_EST_3 ('IBM',v_RSP,v_ERR_DESC);
PROC_EST_3 ('RR',v_RSP,v_ERR_DESC);
PROC_EST_3 ('AMA',v_RSP,v_ERR_DESC);
PROC_EST_3 ('CSCO',v_RSP,v_ERR_DESC);
PROC_EST_3 ('SACYR',v_RSP,v_ERR_DESC);
PROC_EST_3 ('NOKI',v_RSP,v_ERR_DESC);
--============================================================================================================
--                            ESTADSTIC 4
--============================================================================================================
dbms_output.put_line('--============================================================================================================');
dbms_output.put_line('--                            ESTADSTIC 4');
dbms_output.put_line('--============================================================================================================');
proc_BEST_CLIENT (NULL,v_RSP,v_ERR_DESC); -- KO: no indicar data
proc_BEST_CLIENT (DATE '2015-04-25',v_RSP,v_ERR_DESC); 
proc_BEST_CLIENT (DATE '2015-04-30',v_RSP,v_ERR_DESC);
PROC_EST_4 (DATE '2015-04-25',v_RSP,v_ERR_DESC); 
PROC_EST_4 (DATE '2015-06-30',v_RSP,v_ERR_DESC); -- KO: data no correcte
--============================================================================================================
--                            ESTADSTIC 5
--============================================================================================================
dbms_output.put_line('--============================================================================================================');
dbms_output.put_line('--                            ESTADSTIC 5');
dbms_output.put_line('--============================================================================================================');
PROC_UNI_NEGOCIADES (NULL,v_RSP,v_ERR_DESC); -- KO: ERROR 150280, falta la data
PROC_UNI_NEGOCIADES (to_date('13/03/2015','dd/mm/yyyy'),v_RSP,v_ERR_DESC); -- KO: ERROR 150281, en la data indicada no s'han negociat accions
PROC_UNI_NEGOCIADES (to_date('02/04/2015','dd/mm/yyyy'),v_RSP,v_ERR_DESC);  
PROC_EST_5 (to_date('02/04/2015','dd/mm/yyyy'),v_RSP,v_ERR_DESC);
end;