
--Creaci d'un "tablespace" anomenat BROKER_ESPAI que contindr les dades relatives a la BD del broker, els seus clients i llurs carteres, entre molta altre informaci.
CREATE TABLESPACE BROKER_ESPAI 
DATAFILE 'C:\oraclexe\app\oracle\oradata\XE\BROKER_BD\BROKER_BD.DBF'
SIZE 700M
AUTOEXTEND ON NEXT 200M MAXSIZE UNLIMITED
DEFAULT STORAGE (INITIAL 16M NEXT 16M MINEXTENTS 10 MAXEXTENTS 15);
--tamb es crea un 'tablespace' temporal, per poder treballar amb les dades manera local 
create temporary tablespace TMP_BROKER
tempfile 'C:\oraclexe\app\oracle\oradata\XE\BROKER_BD\BROKER_TMP.DBF'
size 2M autoextend on next 50k maxsize UNLIMITED
extent management local uniform size 100k;
-- creaci d'un nou rol
CREATE ROLE TASQUES_BROKER;
-- assignaci de permissos al nou rol
GRANT CREATE SEQUENCE,CREATE SESSION,CREATE TABLE,CREATE VIEW TO TASQUES_BROKER;
-- creaci de l'usuari
CREATE USER BROKER_USER 
IDENTIFIED BY BROKER
DEFAULT TABLESPACE BROKER_ESPAI
TEMPORARY TABLESPACE TMP_BROKER
QUOTA unlimited ON BROKER_ESPAI;
-- ASSIGNACI DEL ROL: TASQUES_BROKER, A L'USUARI BROKER_USER
GRANT TASQUES_BROKER TO BROKER_user;
grant create trigger to broker_user;
GRANT CREATE PROCEDURE TO BROKER_USER;
